"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var webpack_merge_1 = require("webpack-merge");
var pnp_webpack_plugin_1 = __importDefault(require("pnp-webpack-plugin"));
var getOutput_1 = __importDefault(require("./getOutput"));
var getLoaders_1 = __importDefault(require("./getLoaders"));
var getPlugins_1 = __importDefault(require("./getPlugins"));
var getOptimization_1 = __importDefault(require("./getOptimization"));
var utils_1 = __importDefault(require("./utils"));
var entry = ['./src/index'];
exports.default = (function () {
    var configurations = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        configurations[_i] = arguments[_i];
    }
    return webpack_merge_1.merge.apply(void 0, __spreadArrays([{
            mode: utils_1.default.getEnv(),
            performance: {
                hints: false
            },
            devtool: utils_1.default.isDev() ? 'cheap-module-eval-source-map' : false,
            entry: entry,
            output: getOutput_1.default(),
            module: {
                rules: getLoaders_1.default()
            },
            optimization: getOptimization_1.default(),
            plugins: getPlugins_1.default(),
            resolve: {
                plugins: [pnp_webpack_plugin_1.default],
                extensions: ['.js', '.jsx', '.es6', '.json', '.ts', '.tsx']
            },
            resolveLoader: {
                plugins: [
                    pnp_webpack_plugin_1.default.moduleLoader(module)
                ]
            }
        }], configurations));
});
